<template>
  <article class="view view--gallery-albums">
    <LoadingSpinner v-if="loading" />
    <AlbumList
      v-if="loaded"
      :username="username"
      :albums="albums"
      :alias="alias"
      :loading="loading"
      :selecting="selectingWithPermission"
      view="gallery"
      @stale="onStale"
      @album-selected="onAlbumSelected"
    />
  </article>
</template>

<script>
import { ref, computed, onMounted } from 'vue'
import { useRoute } from 'vue-router'
import { useStore } from 'vuex'
import { ValidationHelper, LoadingSpinner, useApi, useNotification } from '../../../core'
import { useAuth } from '../../../identity'
import AlbumsApi from '../../api/albums-api.js'
import AlbumList from '../../components/album-list.vue'

export default {
  name: 'GalleryAlbumsView',
  emits: ['albumLoaded'],
  components: {
    LoadingSpinner,
    AlbumList,
  },
  setup(_, context) {
    const route = useRoute()
    const store = useStore()
    const api = useApi()
    const auth = useAuth()
    const notify = useNotification()
    const albumsApi = new AlbumsApi(api, auth)

    const loading = ref(false)
    const loaded = ref(false)
    const albums = ref([])
    const alias = ref('') // selected album when managing

    const username = computed(() => {
      return ValidationHelper.getString(route.params.username)
    })

    const selecting = computed(() => {
      return ValidationHelper.getBoolean(route.query.selecting, false) && Boolean(store.state.gallery.formName)
    })

    const title = computed(() => {
      return selecting.value ? 'Select image(s)' : `${store.state.identity.session.username}'s Gallery`
    })

    const breadcrumbs = computed(() => {
      return [
        {
          text: 'Users',
          route: { name: 'identity-users' },
        },
        {
          text: username.value,
          route: username.value ? { name: 'identity-user-profile', params: { username: username.value } } : null,
        },
        {
          text: 'Gallery',
          route: null, // No link to self
        },
      ]
    })

    const authenticatedUserId = computed(() => {
      return store.state.identity.session.userId
    })

    const authenticatedUsername = computed(() => {
      return store.state.identity.session.username
    })

    const isCurrentUser = computed(() => {
      return authenticatedUserId.value > 0 && username.value === authenticatedUsername.value
    })

    const selectingWithPermission = computed(() => {
      return selecting.value && store.state.identity.session.userId > 0
    })

    const onAlbumSelected = (album) => {
      if (album && alias.value === album.alias) {
        alias.value = ''
      } else {
        alias.value = album !== null ? album.alias : ''
      }
    }

    const onStale = async () => {
      await loadAsync()
    }

    const loadAsync = async () => {
      loading.value = true
      loaded.value = false
      albums.value = []

      try {
        const response = await albumsApi.fetchAsync({
          username: username.value,
          expand: 'all', // [all|image|user]
          offset: 0,
          limit: 0, // Don't paginate.
        })

        albums.value = response.data
        loaded.value = true

        const album = albums.value.find((a) => a.alias === alias.value)
        if (album) {
          context.emit('albumLoaded', album)
        }
      } catch (ex) {
        notify.error('There was a problem getting the albums.', ex)
      } finally {
        loading.value = false
      }
    }

    onMounted(async () => {
      store.dispatch('core/setTitle', title.value)
      store.dispatch('core/setBreadcrumbs', breadcrumbs.value)
      await loadAsync()
    })

    return {
      loading,
      loaded,
      albums,
      alias,
      username,
      selecting,
      title,
      breadcrumbs,
      authenticatedUserId,
      authenticatedUsername,
      isCurrentUser,
      selectingWithPermission,
      onAlbumSelected,
      onStale,
    }
  },
}
</script>
